# Generated by Django 3.0.11 on 2020-12-20 15:58

from django.db import migrations

CREATE_FUNCTION_SQL = """
CREATE FUNCTION trigger_audit_entry_creator_func_v1() RETURNS TRIGGER AS $scr$
    DECLARE
        object_pk       integer;
        object_payload  varchar;
        request_info    text;
    BEGIN
        request_info := current_setting('django_simple_trigger.request_info', TRUE);

        IF (TG_OP = 'INSERT') THEN
            object_pk       = NEW.id;
            object_payload  = row_to_json(NEW);
        ELSIF (TG_OP = 'UPDATE') THEN
            object_pk       = OLD.id;
            object_payload  = row_to_json(NEW);
        ELSIF (TG_OP = 'DELETE') THEN
            object_pk       = OLD.id;
            object_payload  = row_to_json(OLD);
        ELSE
            RAISE EXCEPTION 'Unexpected TG_OP = %', TG_OP;
        END IF;
        
        INSERT INTO trigger_audit_entries_v1 (
                object_table,
                object_pk,
                object_payload,
                audit_entry_created,
                audit_txid_current,
                audit_operation,
                audit_version,
                audit_request_info
            )
            SELECT
                TG_TABLE_NAME,
                object_pk,
                object_payload,
                now(),
                txid_current(),
                TG_OP,
                1,
                request_info;
        RETURN NULL;
    END;
$scr$ LANGUAGE plpgsql;
"""


class Migration(migrations.Migration):

    dependencies = [
        ('simple_trigger_audit', '0002_trigger_audit_entries_table'),
    ]

    operations = [
        migrations.RunSQL(CREATE_FUNCTION_SQL)
    ]
